import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.plaf.ButtonUI;
import javax.swing.plaf.basic.BasicButtonUI;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.ImageIcon;
import javax.swing.LayoutStyle.ComponentPlacement;
import java.awt.Color;
import javax.swing.UIManager;

/**
 * Voorbeeld van een ronde play/pauze knop (dmv. plaatje).
 * Recept:
 * 1. Maak 1 of meer afbeeldingen die je wil gebruiken voor de knoppen,
 * op de gewenste grootte (bijv. 50x50) en bewaar ze in PNG formaat
 * (je mag hier transparantie gebruiken).
 * 2. Maak een map "images" in de hoofd folder van het project en kopieer daar de
 * afbeeldingen heen.
 * 3. Maak de userinterface met de Window Builder (met gewone JButtons).
 * 4. Voeg de code uit onderstaand voorbeeld in (waar in commentaar 'voeg deze
 * regel in' staat) op de plek waar de JButton met new wordt aangemaakt.
 * Pas de code aan naar je eigen naam voor de Button.
 * Check ook het commentaar bij de GroupLayout.
 *
 * Mocht je meerdere 'states' van de button aan willen passen, kijk dan hier:
 * https://kodejava.org/how-do-i-customize-jbutton-icons/
 * (bijv. Selected, Pressed, Rollover)
 *
 * @author Fjodor van Slooten
 *
 */
public class Button extends JFrame {

	private JPanel contentPane;
	boolean play = false;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Button frame = new Button();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Button() {
		setTitle("Button demo");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBackground(UIManager.getColor("Panel.background"));
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		
		JButton btnPlay = new JButton("");
		btnPlay.setUI((ButtonUI) BasicButtonUI.createUI(btnPlay)); // voeg deze regel in
		btnPlay.setBorder(null); // voeg deze regel in om de rand te verwijderen
		btnPlay.setIcon(new ImageIcon("images/play.png")); // voeg deze regel in
		btnPlay.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				play=!play;
				if (play) btnPlay.setIcon(new ImageIcon("images/pause.png"));
				else btnPlay.setIcon(new ImageIcon("images/play.png"));
			}
		});
		/*
		 * Zoek in onderstaande code de grootte van de button op (DEFAULT_SIZE, PREFERRED_SIZE)
		 * en pas deze aan aan de grootte van de afbeelding.
		 */
		GroupLayout gl_contentPane = new GroupLayout(contentPane);
		gl_contentPane.setHorizontalGroup(
			gl_contentPane.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addGap(177)
					.addComponent(btnPlay, GroupLayout.DEFAULT_SIZE, 48, Short.MAX_VALUE)
					.addGap(200))
		);
		gl_contentPane.setVerticalGroup(
			gl_contentPane.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addContainerGap(182, Short.MAX_VALUE)
					.addComponent(btnPlay, GroupLayout.PREFERRED_SIZE, 48, GroupLayout.PREFERRED_SIZE)
					.addGap(21))
		);
		contentPane.setLayout(gl_contentPane);
	}
}
